Redmine - Defect #13270
Using mysql2 doesn't need mysql gem
2013-02-24 08:50 - Daniel Black

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Database Estimated time: 0.00 hour
Target version:

Resolution: Fixed Affected version:

Description

Doing a install wanted mysql even though all database.yml entries were mysql2.
version r11458

About your application's environment

Ruby version 1.9.3 (x86_64-1inux)
RubyGems version 1.8.25

Rack version 1.4

Rails version 3.2.12

Active Record version 3.2.12

Action Pack version 3.2.12

Active Resource version 3.2.12

Action Mailer version 3.2.12

Active Support version 3.2.12

Middleware Rack::Cache, ActionDispatch::Static, Rack::Lock, #<ActiveSupport::Cache:
:Strategy::LocalCache::Middleware:0x00000003b09818>, Rack::Runtime, Rack::MethodOverride, ActionDi
spatch: :RequestId, Rails::Rack::Logger, ActionDispatch::ShowExceptions, ActionDispatch::DebugExcep
tions, ActionDispatch::Remotelp, ActionDispatch::Callbacks, ActiveRecord::ConnectionAdapters::Conn
ectionManagement, ActiveRecord::QueryCache, ActionDispatch::Cookies, ActionDispatch::Session::Cook
ieStore, ActionDispatch::Flash, ActionDispatch::ParamsParser, ActionDispatch::Head, Rack::Conditio
nalGet, Rack::ETag, ActionDispatch::BestStandardsSupport, OpenIdAuthentication

Application root /usr/local/redmine-new/redmine-2.2-git
Environment production
Database adapter mysql2

Database schema version 20121026003537

-—— a/Gemfile
+++ b/Gemfile
@@ —-44,9 +44,10 @R if File.exist? (database_file)
if adapters.any?
adapters.each do |adapter]|
case adapter
- when /mysql2/
+ gem "mysqgl2", "~> 0.3.11", :platforms => [:mri_19, :mingw_19]
when /mysql/
gem "mysqgl", "~> 2.8.1", :platforms => [:mri_18, :mingw_18]
. gem "mysqgl2", "~> 0.3.11", :platforms => [:mri_19, :mingw_19]
gem "activerecord-jdbcmysgl-adapter", :platforms => :jruby
when /postgresql/
gem "pg", ">= 0.11.0", :platforms => [:mri, :mingw]

don't know if jruby activerecord-jdbcmysql-adapter is needed/available on mysql2.

Associated revisions

Revision 11494 - 2013-02-28 18:20 - Jean-Philippe Lang
Distinguish mysql/mysql2 adapters in Gemfile (#13270).

History

#1 - 2013-02-25 14:08 - Toshi MARUYAMA
https://www.redmine.org/projects/redmine/repository/svn/revisions/11458

/mysql/ is regexp. "mysql" and "mysgl2" are matched.

#2 - 2013-02-25 23:54 - Daniel Black
Toshi MARUYAMA wrote:

/mysql/ is regexp. "mysql" and "mysql2" are matched.

yes. However only the first is matched. in irb:

irb (main) :007:0> case 'mysqgl2'
:008:1> when /mysql2/

:009:1> puts 'mysgl2’'

(
irb (main
irb (main
(
(

)
)
)
)
)
)

irb(main) :010:1> when /mysqgl/
irb(main) :011:1> puts 'mysqgl'
irb(main) :012:1> end

mysql2

=> nil

In the gem file also only mysql2 was pulled in.

#3 - 2013-02-26 00:45 - Toshi MARUYAMA
['mysgl2', 'mysqgl'].each do |adapter]|

case adapter
when /mysql/
puts adapter

end

end

$ ruby test.rb

mysqgl2

mysql

#4 - 2013-02-26 08:18 - Toshi MARUYAMA

- Description updated

fix typo.

#5 - 2013-02-26 12:34 - Etienne Massip

- Status changed from New to Closed

Daniel Black wrote:

Doing a install wanted mysql even though all database.yml entries were mysql2.

This does not make sense, why would you require mysq|l in deps if you only set up mysql2 adapter in your database configuration?

#6 - 2013-02-26 13:00 - Daniel Black

- Status changed from Closed to Reopened

Etienne Massip wrote:
Daniel Black wrote:

Doing a install wanted mysql even though all database.yml entries were mysq|l2.

This does not make sense, why would you require mysqg|l in deps if you only set up mysql2 adapter in your database configuration?

I didn't want mysql there, the Gemfile wanted it installed. | agree it doesn't make sense and hence the whole point of this bug report and the patch to
try to fix it. Maybe /mysql*/ is needed in my first in line patch instead of /mysql/. | just haven't had a chance to test this yet.

#7 - 2013-02-26 15:34 - Etienne Massip

Daniel Black wrote:

| didn't want mysql there, the Gemfile wanted it installed.
Ok, got it. It installed mysql because you are running ruby 1.8 but you want mysql2. Just curious, why would you need mysql2 with 1.87

Maybe /mysql*/ is needed in my first in line patch instead of /mysql/. | just haven't had a chance to test this yet.

Yes, or don't use regex (‘'mysql').
#8 - 2013-02-27 04:47 - Mischa The Evil
Etienne Massip wrote:

Daniel Black wrote:

| didn't want mysql there, the Gemfile wanted it installed.

Ok, got it. It installed mysql because you are running ruby 1.8 but you want mysql2. Just curious, why would you need mysql2 with 1.8?

Looking at the environment info provided in the description, Daniel is not running ruby 1.8. Instead he is running on ruby 1.9; hence his use of mysqgl2.
A question that comes up to me is whether he is running both ruby 1.8 and 1.9? That could might explain why both mysgl and mysqgl2 gems are
installed...

#9 - 2013-02-27 05:12 - Daniel Black
Mischa The Evil wrote:
Etienne Massip wrote:
Daniel Black wrote:

| didn't want mysq| there, the Gemfile wanted it installed.

Ok, got it. It installed mysql because you are running ruby 1.8 but you want mysql2. Just curious, why would you need mysql2 with 1.8?

Looking at the environment info provided in the description, Daniel is not running ruby 1.8. Instead he is running on ruby 1.9; hence his use of
mysq|l2.
yes
A question that comes up to me is whether he is running both ruby 1.8 and 1.9?
I'm faily sure the rvm environment | have has successfully isolated the ruby-1.9 instance from the system ruby-1.8 in path precedence and
RUBY_VERSION and GEM_PATH. | haven't seen the code that determines :mri_18 / :mri_19. ruby18 is still in the path if that gets checked.

That could might explain why both mysql and mysql2 gems are installed...

It could. | had missed the version tags previously.

#10 - 2013-02-27 09:10 - Toshi MARUYAMA

Simple question: Why do you want to install mysql adapter on Ruby 1.9?
There are many trouble feedback of mysql adapter on Ruby 1.9 about character encoding.

#11 - 2013-02-27 12:18 - Daniel Black
Toshi MARUYAMA wrote:
Simple question: Why do you want to install mysql adapter on Ruby 1.9?
Etienne already asked in comment 5. | answered in comment 6. | don't want mysqgl adapter installed and have configured mysql2 already (initial bug
report) and would rather it didn't install mysql adapter. I'll be more verbose about my intent and expectations in future bug reports, particularly the

ones | actually care about like #13287.

Thanks for your fixes in r11489 and r11490. That should be quite sufficient even if it doesn't quite automaticly detect which of the Ruby versions |
have installed is really being used. Its really not worth spending too much time fixing this relatively minor issue.

There are many trouble feedback of mysql adapter on Ruby 1.9 about character encoding.
https://www.redmine.org/issues/13287
https://www.redmine.org/projects/redmine/repository/svn/revisions/11489
https://www.redmine.org/projects/redmine/repository/svn/revisions/11490

good to know.

#12 - 2013-02-27 12:54 - Etienne Massip

Daniel Black wrote:
Toshi MARUYAMA wrote:

Simple question: Why do you want to install mysql adapter on Ruby 1.9?

Etienne already asked in comment 5.

Actually | asked for the opposite question (but it's quite the same in the end): why do you want to install mysql2 adapter on Ruby 1.8?

Thanks for your fixes in r11489 and r11490.

These commits are unrelated, they're about minimal support of Ruby 2.0.

| don't want mysql adapter installed and have configured mysql2 already (initial bug report) and would rather it didn't install mysql adapter

| personnally understood that you wrote the exact opposite with Doing a install wanted mysqgl even though all database.yml entries were mysq|2. :|

Its really not worth spending too much time fixing this relatively minor issue.

There's no issue from our POV: with Ruby 1.8 it will install mysgl and with 1.9, mysql2.

Sorry if | repeat myself or what others already said, but are you sure it installed mysgl gem with Ruby 1.9?

#13 - 2013-02-28 18:24 - Jean-Philippe Lang

- Tracker changed from Patch to Defect

- Subject changed from using mysql2 doesn't need mysql gem to Using mysql2 doesn't need mysql gem
- Status changed from Reopened to Closed

- Resolution set to Fixed

This should be fixed in r11494. gem "mysql" is no longer called when using the mysql2 adapter.

#14 - 2013-02-28 22:29 - Daniel Black
thankyou

#15 - 2013-03-01 10:36 - Etienne Massip

- Status changed from Closed to Reopened
Why change?

Excerpt of AR-JDBC adapter Readme:

Configure your database.yml in the normal Rails style.

Legacy configuration: If you use one of the convenience activerecord-jdbcXXX-adapter adapters,

ut a 'jdbc' prefix in front of the database adapter name e.g.

development:
adapter: jdbcmysgl
username: blog
password:
host: localhost
database: weblog_development

We can't use jdbcmysgl name anymore with r11494 but activerecord-jdbcmysql-adapter is a dependency in Gemfile?

#16 - 2013-03-01 11:16 - Jean-Philippe Lang

The 'jJdbc' prefix is not required, you can just set adapter: mysq|l.
https://www.redmine.org/projects/redmine/repository/svn/revisions/11489
https://www.redmine.org/projects/redmine/repository/svn/revisions/11490
https://www.redmine.org/projects/redmine/repository/svn/revisions/11494
https://www.redmine.org/projects/redmine/repository/svn/revisions/11494

#17 - 2018-03-31 08:58 - Go MAEDA

- Status changed from Reopened to Closed

Jean-Philippe Lang wrote:

The 'jdbc' prefix is not required, you can just set adapter: mysq|.

And current versions of Redmine don't support jruby any longer.
